<html>
<head>
<title>OgreGLSLGpuProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_4557aaee8cf510d5b035fe0c2c5dd433.html">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_81e02400f093837e2a11409f96e5fd4f.html">GLSL</a>      </li>
      <li class="navelem"><a class="el" href="dir_2fa9b21d57931d849b3ca4a2f6225bef.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLSLGpuProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLSLGpuProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __GLSLGpuProgram_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __GLSLGpuProgram_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// Precompiler options</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLSLExtSupport_8h.html">OgreGLSLExtSupport.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLGpuProgram_8h.html">OgreGLGpuProgram.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Ogre {
<a name="l00038"></a>00038 
<a name="l00048"></a><a class="code" href="classOgre_1_1GLSLGpuProgram.html">00048</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1GLGpuProgram.html" title="Generalised low-level GL program, can be applied to multiple types (eg ARB and NV)">GLGpuProgram</a>
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050     <span class="keyword">private</span>:
<a name="l00052"></a><a class="code" href="classOgre_1_1GLSLGpuProgram.html#aa1ac8989329d9918cb85d28c913b1e92">00052</a>         <a class="code" href="classOgre_1_1GLSLProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL)...">GLSLProgram</a>* <a class="code" href="classOgre_1_1GLSLGpuProgram.html#aa1ac8989329d9918cb85d28c913b1e92" title="GL Handle for the shader object.">mGLSLProgram</a>;
<a name="l00053"></a>00053 
<a name="l00055"></a><a class="code" href="classOgre_1_1GLSLGpuProgram.html#abc927473c392da42ec99beed297a5c41">00055</a>         <span class="keyword">static</span> GLuint <a class="code" href="classOgre_1_1GLSLGpuProgram.html#abc927473c392da42ec99beed297a5c41" title="Keep track of the number of vertex shaders created.">mVertexShaderCount</a>;
<a name="l00057"></a><a class="code" href="classOgre_1_1GLSLGpuProgram.html#ab5c203ae6f9a93b7317f6192bd0b1e31">00057</a>         <span class="keyword">static</span> GLuint <a class="code" href="classOgre_1_1GLSLGpuProgram.html#ab5c203ae6f9a93b7317f6192bd0b1e31" title="Keep track of the number of fragment shaders created.">mFragmentShaderCount</a>;
<a name="l00059"></a><a class="code" href="classOgre_1_1GLSLGpuProgram.html#add8aeb5eb59316e5dfd77a45fae1ca6a">00059</a>         <span class="keyword">static</span> GLuint <a class="code" href="classOgre_1_1GLSLGpuProgram.html#add8aeb5eb59316e5dfd77a45fae1ca6a" title="keep track of the number of geometry shaders created">mGeometryShaderCount</a>;
<a name="l00060"></a>00060 
<a name="l00061"></a>00061     <span class="keyword">public</span>:
<a name="l00062"></a>00062         <a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>(<a class="code" href="classOgre_1_1GLSLProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL)...">GLSLProgram</a>* parent);
<a name="l00063"></a>00063         ~<a class="code" href="classOgre_1_1GLSLGpuProgram.html" title="GLSL low level compiled shader object - this class is used to get at the linked program object and pr...">GLSLGpuProgram</a>();
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00067"></a>00067         <span class="keywordtype">void</span> bindProgram(<span class="keywordtype">void</span>);
<a name="l00069"></a>00069         <span class="keywordtype">void</span> unbindProgram(<span class="keywordtype">void</span>);
<a name="l00071"></a>00071         <span class="keywordtype">void</span> bindProgramParameters(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> mask);
<a name="l00073"></a>00073         <span class="keywordtype">void</span> bindProgramPassIterationParameters(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params);
<a name="l00074"></a>00074 
<a name="l00076"></a><a class="code" href="classOgre_1_1GLSLGpuProgram.html#a6be0dfb990d5116d4ea1ed688700cb83">00076</a>         GLuint getProgramID(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00077"></a>00077 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mProgramID; }
<a name="l00078"></a>00078 
<a name="l00080"></a><a class="code" href="classOgre_1_1GLSLGpuProgram.html#a74a94c7828dea213862bb76ca3248d85">00080</a>         <a class="code" href="classOgre_1_1GLSLProgram.html" title="Specialisation of HighLevelGpuProgram to provide support for OpenGL Shader Language (GLSL)...">GLSLProgram</a>* <a class="code" href="classOgre_1_1GLSLGpuProgram.html#a74a94c7828dea213862bb76ca3248d85" title="Get the GLSLProgram for the shader object.">getGLSLProgram</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mGLSLProgram; }
<a name="l00081"></a>00081 
<a name="l00083"></a>00083         GLuint getAttributeIndex(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> index);
<a name="l00084"></a>00084         
<a name="l00086"></a>00086         <span class="keywordtype">bool</span> isAttributeValid(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> index);
<a name="l00087"></a>00087         
<a name="l00088"></a>00088 
<a name="l00089"></a>00089     <span class="keyword">protected</span>:
<a name="l00091"></a>00091         <span class="keywordtype">void</span> loadFromSource(<span class="keywordtype">void</span>);
<a name="l00093"></a>00093         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00095"></a>00095         <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098     };
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 <span class="preprocessor">#endif // __GLSLGpuProgram_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
